org.apache.commons.imaging.formats.wbmp

## Class WbmpImageParser

- java.lang.Object
- - org.apache.commons.imaging.common.BinaryFileParser
  - - org.apache.commons.imaging.ImageParser
    - - org.apache.commons.imaging.formats.wbmp.WbmpImageParser

-     public class WbmpImageParser
      extends ImageParser

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `WbmpImageParser()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `dumpImageFile(PrintWriter pw, ByteSource byteSource)` Write the ImageInfo and format-specific information for the image content of the specified byte source to a PrintWriter
    `protected String[]` | `getAcceptedExtensions()` Get an array of all accepted extensions
    `protected ImageFormat[]` | `getAcceptedTypes()` Get an array of ImageFormat objects describing all accepted types
    `BufferedImage` | `getBufferedImage(ByteSource byteSource, Map<String,Object> params)` Gets a buffered image specified by the byte source (for sources that specify multiple images, choice of which image is returned is implementation dependent).
    `String` | `getDefaultExtension()` Get the default extension for the format specified by an implementation of ImageParser.
    `byte[]` | `getICCProfileBytes(ByteSource byteSource, Map<String,Object> params)` Get an array of bytes describing the International Color Consortium (ICC) specification for the color space of the image contained in the input byteSource.
    `ImageInfo` | `getImageInfo(ByteSource byteSource, Map<String,Object> params)` Get image information from the specified ByteSource.
    `Dimension` | `getImageSize(ByteSource byteSource, Map<String,Object> params)` Get the size of the image described by the specified ByteSource.
    `ImageMetadata` | `getMetadata(ByteSource byteSource, Map<String,Object> params)` Get image metadata from the specified byte source.
    `String` | `getName()` Get a descriptive name for the implementation of an ImageParser.
    `void` | `writeImage(BufferedImage src, OutputStream os, Map<String,Object> params)` Writes the content of a BufferedImage to the specified output stream.

    - ### Methods inherited from class org.apache.commons.imaging.ImageParser

      `canAcceptExtension, canAcceptExtension, canAcceptType, dumpImageFile, dumpImageFile, dumpImageFile, getAllBufferedImages, getAllBufferedImages, getAllBufferedImages, getAllImageParsers, getBufferedImage, getBufferedImage, getBufferedImageFactory, getFormatCompliance, getFormatCompliance, getFormatCompliance, getICCProfileBytes, getICCProfileBytes, getICCProfileBytes, getICCProfileBytes, getImageInfo, getImageInfo, getImageInfo, getImageSize, getImageSize, getImageSize, getImageSize, getMetadata, getMetadata, getMetadata, getMetadata, getMetadata, isStrict`

    - ### Methods inherited from class org.apache.commons.imaging.common.BinaryFileParser

      `debugNumber, debugNumber, getByteOrder, setByteOrder`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### WbmpImageParser

          public WbmpImageParser()

  - ### Method Detail

    - #### getName

          public String getName()

      Description copied from class: `ImageParser`
      Get a descriptive name for the implementation of an ImageParser.
      Specified by:
        `getName` in class `ImageParser`
      Returns:
        a valid, subject-matter-specific string.

    - #### getDefaultExtension

          public String getDefaultExtension()

      Description copied from class: `ImageParser`
      Get the default extension for the format specified by an implementation of ImageParser. Some parsers can support more than one extension (i.e. .JPEG, .JPG; .TIF, .TIFF, etc.).
      Specified by:
        `getDefaultExtension` in class `ImageParser`
      Returns:
        A valid string.

    - #### getAcceptedExtensions

          protected String[] getAcceptedExtensions()

      Description copied from class: `ImageParser`
      Get an array of all accepted extensions
      Specified by:
        `getAcceptedExtensions` in class `ImageParser`
      Returns:
        A valid array of one or more elements.

    - #### getAcceptedTypes

          protected ImageFormat[] getAcceptedTypes()

      Description copied from class: `ImageParser`
      Get an array of ImageFormat objects describing all accepted types
      Specified by:
        `getAcceptedTypes` in class `ImageParser`
      Returns:
        A valid array of one or more elements.

    - #### getMetadata

          public ImageMetadata getMetadata(ByteSource byteSource,
                                           Map<String,Object> params)
                                    throws ImageReadException,
                                           IOException

      Description copied from class: `ImageParser`
      Get image metadata from the specified byte source. Format-specific ImageParser implementations are expected to return a valid IImageMetadata object or to throw an ImageReadException if unable to process the specified byte source.

      The params argument provides a mechanism for individual implementations to pass optional information into the parser. Not all formats will require this capability. Because the base class may call this method with a null params argument, implementations should always include logic for ignoring null input.

      Specified by:
        `getMetadata` in class `ImageParser`
      Parameters:
        `byteSource` - A valid byte source.
        `params` - Optional instructions for special-handling or interpretation of the input data (null objects are permitted and must be supported by implementations).
      Returns:
        A valid, potentially subject-matter-specific implementation of the IImageMetadata interface describing the content extracted from the source content.
      Throws:
        `ImageReadException` - In the event that the ByteSource content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful data read operation.

    - #### getImageInfo

          public ImageInfo getImageInfo(ByteSource byteSource,
                                        Map<String,Object> params)
                                 throws ImageReadException,
                                        IOException

      Description copied from class: `ImageParser`
      Get image information from the specified ByteSource. Format-specific ImageParser implementations are expected to return a valid ImageInfo object or to throw an ImageReadException if unable to process the specified data.

      The params argument provides a mechanism for individual implementations to pass optional information into the parser. Not all formats will require this capability. Because the base class may call this method with a null params argument, implementations should always include logic for ignoring null input.

      Specified by:
        `getImageInfo` in class `ImageParser`
      Parameters:
        `byteSource` - A valid ByteSource object
        `params` - Optional instructions for special-handling or interpretation of the input data (null objects are permitted and must be supported by implementations).
      Returns:
        A valid image information object describing the content extracted from the specified data.
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful data access operation.

    - #### getImageSize

          public Dimension getImageSize(ByteSource byteSource,
                                        Map<String,Object> params)
                                 throws ImageReadException,
                                        IOException

      Description copied from class: `ImageParser`
      Get the size of the image described by the specified ByteSource.
      Specified by:
        `getImageSize` in class `ImageParser`
      Parameters:
        `byteSource` - A valid reference to a ByteSource.
        `params` - Optional instructions for special-handling or interpretation of the input data.
      Returns:
        A valid instance of Dimension.
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful read or access operation.

    - #### getICCProfileBytes

          public byte[] getICCProfileBytes(ByteSource byteSource,
                                           Map<String,Object> params)
                                    throws ImageReadException,
                                           IOException

      Description copied from class: `ImageParser`
      Get an array of bytes describing the International Color Consortium (ICC) specification for the color space of the image contained in the input byteSource. Not all formats support ICC profiles.
      Specified by:
        `getICCProfileBytes` in class `ImageParser`
      Parameters:
        `byteSource` - A valid ByteSource.
        `params` - Optional instructions for special-handling or interpretation of the input data.
      Returns:
        If available, a valid array of bytes; otherwise, a null
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful read or access operation.

    - #### dumpImageFile

          public boolean dumpImageFile(PrintWriter pw,
                                       ByteSource byteSource)
                                throws ImageReadException,
                                       IOException

      Description copied from class: `ImageParser`
      Write the ImageInfo and format-specific information for the image content of the specified byte source to a PrintWriter
      Overrides:
        `dumpImageFile` in class `ImageParser`
      Parameters:
        `pw` - print writer used for writing the ImageInfo
        `byteSource` - A valid byte source.
      Returns:
        A valid PrintWriter.
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful read or access operation.

    - #### getBufferedImage

          public final BufferedImage getBufferedImage(ByteSource byteSource,
                                                      Map<String,Object> params)
                                               throws ImageReadException,
                                                      IOException

      Description copied from class: `ImageParser`
      Gets a buffered image specified by the byte source (for sources that specify multiple images, choice of which image is returned is implementation dependent).
      Specified by:
        `getBufferedImage` in class `ImageParser`
      Parameters:
        `byteSource` - A valid instance of ByteSource
        `params` - Optional instructions for special-handling or interpretation of the input data (null objects are permitted and must be supported by implementations).
      Returns:
        A valid instance of BufferedImage.
      Throws:
        `ImageReadException` - In the event that the specified content does not conform to the format of the specific parser implementation.
        `IOException` - In the event of unsuccessful read or access operation.

    - #### writeImage

          public void writeImage(BufferedImage src,
                                 OutputStream os,
                                 Map<String,Object> params)
                          throws ImageWriteException,
                                 IOException

      Description copied from class: `ImageParser`
      Writes the content of a BufferedImage to the specified output stream.

      The params argument provides a mechanism for individual implementations to pass optional information into the parser. Not all formats will support this capability. Currently, some of the parsers do not check for null arguments. So in cases where no optional specifications are supported, application code should pass in an empty instance of an implementation of the map interface (i.e. an empty HashMap).

      Overrides:
        `writeImage` in class `ImageParser`
      Parameters:
        `src` - An image giving the source content for output
        `os` - A valid output stream for storing the formatted image
        `params` - A non-null Map implementation supplying optional, format-specific instructions for output (such as selections for data compression, color models, etc.)
      Throws:
        `ImageWriteException` - In the event that the output format cannot handle the input image or invalid params are specified.
        `IOException` - In the event of an write error from the output stream.

Copyright © 2007–2020 The Apache Software Foundation. All rights reserved.